Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QSyntaxHighlighter

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QSyntaxHighlighter

All Implemented Interfaces:
  QtJambiInterface

    public abstract class QSyntaxHighlighter

extends QObject

The `QSyntaxHighlighter` class allows you to define syntax highlighting rules, and in addition you can use the class to query a document's current formatting or user data. The `QSyntaxHighlighter` class is a base class for implementing `QTextEdit` syntax highlighters. A syntax highligher automatically highlights parts of the text in a `QTextEdit`, or more generally in a `QTextDocument`. Syntax highlighters are often used when the user is entering text in a specific format (for example source code) and help the user to read the text and identify syntax errors.

To provide your own syntax highlighting, you must subclass `QSyntaxHighlighter` and reimplement `highlightBlock()`.

When you create an instance of your `QSyntaxHighlighter` subclass, pass it the `QTextEdit` or `QTextDocument` that you want the syntax highlighting to be applied to. For example:

               QTextEdit editor = new QTextEdit();
               MyHighlighter highlighter = new MyHighlighter(editor.document());

After this your `highlightBlock()` function will be called automatically whenever necessary. Use your `highlightBlock()` function to apply formatting (e.g. setting the font and color) to the text that is passed to it. `QSyntaxHighlighter` provides the `setFormat()` function which applies a given `QTextCharFormat` on the current text block. For example:

            protected void highlightBlock(String text)
            {
                QTextCharFormat myClassFormat = new QTextCharFormat();
                myClassFormat.setFontWeight(QFont.Weight.Bold.value());
                myClassFormat.setForeground(new QBrush(QColor.darkMagenta));
                String pattern = "\\bMy[A-Za-z]+\\b";

                QRegExp expression = new QRegExp(pattern);
                int index = expression.indexIn(text);
                while (index >= 0) {
                    int length = expression.matchedLength();
                    setFormat(index, length, myClassFormat);
                    index = expression.indexIn(text, index + length);
                 }
             }

Some syntaxes can have constructs that span several text blocks. For example, a C++ syntax highlighter should be able to cope with `/``*...*``/` multiline comments. To deal with these cases it is necessary to know the end state of the previous text block (e.g. "in comment").

Inside your `highlightBlock()` implementation you can query the end state of the previous text block using the `previousBlockState()` function. After parsing the block you can save the last state using `setCurrentBlockState()`.

The `currentBlockState()` and `previousBlockState()` functions return an int value. If no state is set, the returned value is -1. You can designate any other value to identify any given state using the `setCurrentBlockState()` function. Once the state is set the `QTextBlock` keeps that value until it is set set again or until the corresponding paragraph of text is deleted.

For example, if you're writing a simple C++ syntax highlighter, you might designate 1 to signify "in comment":

            QTextCharFormat multiLineCommentFormat = new QTextCharFormat();
            multiLineCommentFormat.setForeground(new QBrush(QColor.red));

            QRegExp startExpression = new QRegExp("/\\*");
            QRegExp endExpression = new QRegExp("\\* /");

            setCurrentBlockState(0);

            int startIndex = 0;
            if (previousBlockState() != 1)
                startIndex = startExpression.indexIn(text);

            while (startIndex >= 0) {
               int endIndex = endExpression.indexIn(text, startIndex);
               int commentLength;
               if (endIndex == -1) {
                   setCurrentBlockState(1);
                   commentLength = text.length() - startIndex;
               } else {
                   commentLength = endIndex - startIndex
                                   + endExpression.matchedLength();
               }
               setFormat(startIndex, commentLength, multiLineCommentFormat);
               startIndex = startExpression.indexIn(text,
                                         startIndex + commentLength);
            }

In the example above, we first set the current block state to 0. Then, if the previous block ended within a comment, we higlight from the beginning of the current block (`startIndex = 0`). Otherwise, we search for the given start expression. If the specified end expression cannot be found in the text block, we change the current block state by calling `setCurrentBlockState()`, and make sure that the rest of the block is higlighted.

In addition you can query the current formatting and user data using the `format()` and `currentBlockUserData()` functions respectively. You can also attach user data to the current text block using the `setCurrentBlockUserData()` function. `QTextBlockUserData` can be used to store custom settings. In the case of syntax highlighting, it is in particular interesting as cache storage for information that you may figure out while parsing the paragraph's text. For an example, see the `setCurrentBlockUserData()` documentation.

See also:
  `QTextEdit`, and Syntax Highlighter Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QSyntaxHighlighter(QObject parent)` Constructs a `QSyntaxHighlighter` with the given `parent`.
`QSyntaxHighlighter(QTextDocument parent)` Constructs a `QSyntaxHighlighter` and installs it on `parent`.
`QSyntaxHighlighter(QTextEdit parent)` Constructs a `QSyntaxHighlighter` and installs it on `parent` 's `QTextDocument`.

Method Summary
`protected QTextBlock` | `currentBlock()` Returns the current text block.
`protected int` | `currentBlockState()` Returns the state of the current text block.
`protected QTextBlockUserData` | `currentBlockUserData()` Returns the `QTextBlockUserData` object previously attached to the current text block.
`QTextDocument` | `document()` Returns the `QTextDocument` on which this syntax highlighter is installed.
`protected QTextCharFormat` | `format(int pos)` Returns the format at `position` inside the syntax highlighter's current text block.
`protected abstract void` | `highlightBlock(java.lang.String text)` Highlights the given text block.
`protected int` | `previousBlockState()` Returns the end state of the text block previous to the syntax highlighter's current block.
`void` | `rehighlight()` Redoes the highlighting of the whole document.
`protected void` | `setCurrentBlockState(int newState)` Sets the state of the current text block to `newState`.
`protected void` | `setCurrentBlockUserData(QTextBlockUserData data)` Attaches the given `data` to the current text block.
`void` | `setDocument(QTextDocument doc)` Installs the syntax highlighter on the given `QTextDocument` `doc`.
`protected void` | `setFormat(int start, int count, QColor color)` The specified `color` is applied to the current text block from the `start` position for a length of `count` characters.
`protected void` | `setFormat(int start, int count, QFont font)` The specified `font` is applied to the current text block from the `start` position for a length of `count` characters.
`protected void` | `setFormat(int start, int count, QTextCharFormat format)` This function is applied to the syntax highlighter's current text block (i.

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QSyntaxHighlighter

    public QSyntaxHighlighter(QObject parent)

  Constructs a `QSyntaxHighlighter` with the given `parent`.

### QSyntaxHighlighter

    public QSyntaxHighlighter(QTextDocument parent)

  Constructs a `QSyntaxHighlighter` and installs it on `parent`. The specified `QTextDocument` also becomes the owner of the `QSyntaxHighlighter`.

### QSyntaxHighlighter

    public QSyntaxHighlighter(QTextEdit parent)

  Constructs a `QSyntaxHighlighter` and installs it on `parent` 's `QTextDocument`. The specified `QTextEdit` also becomes the owner of the `QSyntaxHighlighter`.

Method Detail

### currentBlock

    protected final QTextBlock currentBlock()

  Returns the current text block.

### currentBlockState

    protected final int currentBlockState()

  Returns the state of the current text block. If no value is set, the returned value is -1.

See also:
  `setCurrentBlockState()`.

### currentBlockUserData

    protected final QTextBlockUserData currentBlockUserData()

  Returns the `QTextBlockUserData` object previously attached to the current text block.

See also:
  `QTextBlock::userData()`, and `setCurrentBlockUserData()`.

### document

    public final QTextDocument document()

  Returns the `QTextDocument` on which this syntax highlighter is installed.

See also:
  `setDocument()`.

### format

    protected final QTextCharFormat format(int pos)

  Returns the format at `position` inside the syntax highlighter's current text block.

See also:
  `setFormat()`.

### previousBlockState

    protected final int previousBlockState()

  Returns the end state of the text block previous to the syntax highlighter's current block. If no value was previously set, the returned value is -1.

See also:
  `highlightBlock()`, and `setCurrentBlockState()`.

### rehighlight

    public final void rehighlight()

  Redoes the highlighting of the whole document.

### setCurrentBlockState

    protected final void setCurrentBlockState(int newState)

  Sets the state of the current text block to `newState`.

See also:
  `currentBlockState()`, and `highlightBlock()`.

### setCurrentBlockUserData

    protected final void setCurrentBlockUserData(QTextBlockUserData data)

  Attaches the given `data` to the current text block. The ownership is passed to the underlying text document, i.e. the provided `QTextBlockUserData` object will be deleted if the corresponding text block gets deleted.

  `QTextBlockUserData` can be used to store custom settings. In the case of syntax highlighting, it is in particular interesting as cache storage for information that you may figure out while parsing the paragraph's text.

  For example while parsing the text, you can keep track of parenthesis characters that you encounter ('{[(' and the like), and store their relative position and the actual QChar in a simple class derived from `QTextBlockUserData`:

              class ParenthesisInfo
              {
                  char character;
                  int position;
              }

              class BlockData extends QTextBlockUserData
              {
                  List<ParenthesisInfo> parentheses;
              }

  During cursor navigation in the associated editor, you can ask the current `QTextBlock` (retrieved using the `QTextCursor::block()` function) if it has a user data object set and cast it to your `BlockData` object. Then you can check if the current cursor position matches with a previously recorded parenthesis position, and, depending on the type of parenthesis (opening or closing), find the next opening or closing parenthesis on the same level.

  In this way you can do a visual parenthesis matching and highlight from the current cursor position to the matching parenthesis. That makes it easier to spot a missing parenthesis in your code and to find where a corresponding opening/closing parenthesis is when editing parenthesis intensive code.

See also:
  `currentBlockUserData()`, and `QTextBlock::setUserData()`.

### setDocument

    public final void setDocument(QTextDocument doc)

  Installs the syntax highlighter on the given `QTextDocument` `doc`. A `QSyntaxHighlighter` can only be used with one document at a time.

See also:
  `document()`.

### setFormat

    protected final void setFormat(int start,
                                   int count,
                                   QColor color)

  The specified `color` is applied to the current text block from the `start` position for a length of `count` characters.

  The other attributes of the current text block, e.g. the font and background color, are reset to default values.

See also:
  `format()`, and `highlightBlock()`.

### setFormat

    protected final void setFormat(int start,
                                   int count,
                                   QFont font)

  The specified `font` is applied to the current text block from the `start` position for a length of `count` characters.

  The other attributes of the current text block, e.g. the font and background color, are reset to default values.

See also:
  `format()`, and `highlightBlock()`.

### setFormat

    protected final void setFormat(int start,
                                   int count,
                                   QTextCharFormat format)

  This function is applied to the syntax highlighter's current text block (i. . the text that is passed to the `highlightBlock()` function).

  The specified `format` is applied to the text from the `start` position for a length of `count` characters (if `count` is 0, nothing is done). The formatting properties set in `format` are merged at display time with the formatting information stored directly in the document, for example as previously set with `QTextCursor`'s functions. Note that the document itself remains unmodified by the format set through this function.

See also:
  `format()`, and `highlightBlock()`.

### highlightBlock

    protected abstract void highlightBlock(java.lang.String text)

  Highlights the given text block. This function is called when necessary by the rich text engine, i.e. on text blocks which have changed.

  To provide your own syntax highlighting, you must subclass `QSyntaxHighlighter` and reimplement `highlightBlock()`. In your reimplementation you should parse the block's `text` and call `setFormat()` as often as necessary to apply any font and color changes that you require. For example:

              protected void highlightBlock(String text)
              {
                  QTextCharFormat myClassFormat = new QTextCharFormat();
                  myClassFormat.setFontWeight(QFont.Weight.Bold.value());
                  myClassFormat.setForeground(new QBrush(QColor.darkMagenta));
                  String pattern = "\\bMy[A-Za-z]+\\b";

                  QRegExp expression = new QRegExp(pattern);
                  int index = expression.indexIn(text);
                  while (index >= 0) {
                      int length = expression.matchedLength();
                      setFormat(index, length, myClassFormat);
                      index = expression.indexIn(text, index + length);
                   }
               }

  Some syntaxes can have constructs that span several text blocks. For example, a C++ syntax highlighter should be able to cope with `/``*...*``/` multiline comments. To deal with these cases it is necessary to know the end state of the previous text block (e.g. "in comment").

  Inside your `highlightBlock()` implementation you can query the end state of the previous text block using the `previousBlockState()` function. After parsing the block you can save the last state using `setCurrentBlockState()`.

  The `currentBlockState()` and `previousBlockState()` functions return an int value. If no state is set, the returned value is -1. You can designate any other value to identify any given state using the `setCurrentBlockState()` function. Once the state is set the `QTextBlock` keeps that value until it is set set again or until the corresponding paragraph of text gets deleted.

  For example, if you're writing a simple C++ syntax highlighter, you might designate 1 to signify "in comment". For a text block that ended in the middle of a comment you'd set 1 using setCurrentBlockState, and for other paragraphs you'd set 0. In your parsing code if the return value of `previousBlockState()` is 1, you would highlight the text as a C++ comment until you reached the closing `*``/`.

See also:
  `previousBlockState()`, `setFormat()`, and `setCurrentBlockState()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD